﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;

using iTextSharp.text;
using iTextSharp.text.pdf;
using System.IO;

namespace basekibali
{
    public class Master
    {
        public int GetAccessLevel(string username)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();

            if (username == "" || username == null) return -1;
            var user = from x in db.SECURITies
                       where x.Username == username
                       select new
                       {
                           accesslevel = x.AccessLevel
                       };
            foreach (var value in user)
            {
                return value.accesslevel;
            }
            return -1;
        }
        public void SetDropDown(DropDownList ddl, IQueryable source)
        {
            ddl.AppendDataBoundItems = true;
            ddl.DataSource = source;
            ddl.DataTextField = "Text";
            ddl.DataValueField = "Value";
            ddl.DataBind();
        }
        public void SetDropDownReloaded(DropDownList ddl, string FirstValue, IQueryable source)
        {
            string ddlValue = ddl.SelectedValue;

            ddl.DataSource = null;
            ddl.Items.Clear();

            DataSet dsResult = new DataSet();
            DataRow drRev;
            DataTable dtRev = new DataTable();
            dtRev.Columns.Add("Value");
            dtRev.Columns.Add("Text");
            drRev = dtRev.NewRow();
            drRev[0] = "0";
            drRev[1] = FirstValue;
            dtRev.Rows.Add(drRev);
            dsResult.Tables.Add(dtRev);
            ddl.DataSource = dsResult;
            ddl.DataTextField = "Text";
            ddl.DataValueField = "Value";
            ddl.DataBind();

            SetDropDown(ddl, source);

            ddl.SelectedValue = ddlValue;
        }
        /*Get villages for drop down menu*/
        public IQueryable GetVillagesForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.VILLAGEs
                        select new
                        {
                            Text = v.Name,
                            Value = v.Name
                        };
            return items.OrderBy(x => x.Text);
        }
        /*Get projects for drop down menu*/
        public IQueryable GetProjectsForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from p in db.PROJECTs
                        select new
                        {
                            Text = p.Name,
                            Value = p.Name
                        };
            return items.OrderBy(x => x.Text);
        }

        bool compstatus = false;
        public void DisplayInfo(string theId, string task, Label disp)
        {
            DataKibaliDataContext dbclaimer = new DataKibaliDataContext();
            var claimer =
                from person in dbclaimer.HHCLAIMERs
                from hh in dbclaimer.HOUSEHOLDs
                where person.IDnumber == theId && person.HHNumber == hh.HHNumber
                select new
                {
                    HHNumber = hh.HHNumber,
                    village = hh.Village,
                    HHhead = hh.HHhead,
                    thedate = hh.InterviewDate,
                    photo = hh.PhotoPath,
                    person = person.HHFirstName,
                    first = person.HHFirstName,
                    mid = person.HHMiddleName,
                    fam = person.HHFamName,
                    id = person.IDnumber,
                    interviewer = person.Interviewer,
                    sup = person.Supervised,
                    chief = person.Chiefed,
                    status = person.AgriCompStatus
                };


            DataKibaliDataContext dbadd = new DataKibaliDataContext();
            var additional =
                from add in dbadd.FURTHER_INFOs
                where add.IDnumber == theId
                select new
                {
                    unresearched = add.FTunresearched,
                    location = add.Location,
                    RespComm = add.RespComm,
                    Fieldcomm = add.FieldComm
                };


            DataKibaliDataContext dbfield = new DataKibaliDataContext();
            var field =
                from thefield in dbfield.COMP_FIELDs
                where thefield.IDnumber == theId
                select new
                {
                    Ownership = thefield.Ownership,
                    Dimension = thefield.Dimension,
                    Cultiv = thefield.Cultiv,
                    ProjectTask = thefield.ProjectTask,
                    FieldCode = thefield.FieldCode,
                    GpsN = thefield.GpsN,
                    GpsE = thefield.GpsE
                };
            if (task != "")
            {
                field =
                from thefield in dbfield.COMP_FIELDs
                where thefield.IDnumber == theId && thefield.ProjectTask == task
                select new
                {
                    Ownership = thefield.Ownership,
                    Dimension = thefield.Dimension,
                    Cultiv = thefield.Cultiv,
                    ProjectTask = thefield.ProjectTask,
                    FieldCode = thefield.FieldCode,
                    GpsN = thefield.GpsN,
                    GpsE = thefield.GpsE
                };
            }

            DataKibaliDataContext dbtree = new DataKibaliDataContext();
            var tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == theId
                    select new
                    {
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask,
                        GpsN = thetree.GpsN,
                        GpsE = thetree.GpsE
                    };
            if (task != "")
            {
                tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == theId && thetree.ProjectTask == task
                    select new
                    {
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask,
                        GpsN = thetree.GpsN,
                        GpsE = thetree.GpsE
                    };
            }
            /*DISLAYING DATA*/
            disp.Text = "";
            if (task != "")
            {
                disp.Text = "*Note that the below household may have fields/trees not affected by \"<b>" + task + "</b>\" and not listed here<br /><br />";
            }

            /*general info & household details*/
            foreach (var value in claimer)
            {

                disp.Text += "<table>";
                if (value.photo == "1")
                {
                    disp.Text += "<tr align=\"center\"><td><img src=\"Photos/" + value.HHNumber + "_thumb.jpg\" alt=\"Head of House\" /></td></tr>";
                    disp.Text += "<tr align=\"center\"><td>" + value.HHhead + "</td></tr>";
                }
                else disp.Text += "<tr align=\"center\"><td><img src=\"default.jpg\" alt=\"Head of House\" /></td></tr>";
                disp.Text += "</table>";

                disp.Text += "<center><strong><u>GENERAL INFORMATION</u></strong></center>";
                disp.Text += "<table>";
                disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>First Name:</td><td>" + value.first + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Middle name:</td><td>" + value.mid + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Family name:</td><td>" + value.fam + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Id Number:</td><td>" + value.id + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Interviewer:</td><td>" + value.interviewer + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Verified by Fieldwork Supervisor:</td><td>" + boolvalue(Convert.ToBoolean(value.sup)) + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Verified by Chef de village/Camp:</td><td>" + boolvalue(Convert.ToBoolean(value.chief)) + "</td></tr>";
                disp.Text += "</table>";

                DateTime ladate = Convert.ToDateTime(value.thedate);
                disp.Text += "<br /><center><strong><u>HOUSEHOLD DETAILS</u></strong></center>";
                disp.Text += "<table>";
                disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Village:</td><td>" + value.village + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>HH number:</td><td>" + value.HHNumber + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Name of Household head:</td><td>" + value.HHhead + "</td></tr>";
                disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Interview date:</td><td>" + ladate.ToString("MMMM dd, yyyy") + "</td></tr>";
                disp.Text += "</table><br/>";
            }

            /*additional info*/
            if (additional.Count() > 0)
            {
                if ((additional.First().unresearched == false) && (additional.First().location == "") && (additional.First().RespComm == "") && (additional.First().Fieldcomm == ""))
                {
                }
                else
                {
                    foreach (var value in additional)
                    {
                        disp.Text += "<br /><center><strong><u>ADDITIONAL INFORMATION</u></strong></center>";
                        disp.Text += "<table>";
                        disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Other Fields/Trees Unresearched?:</td><td>" + boolvalue(Convert.ToBoolean(value.unresearched)) + "</td></tr>";
                        disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Location:</td><td>" + value.location + "</td></tr>";
                        disp.Text += "<tr bgcolor=\"#D1DDF1\"><td>Respondant Comments:</td><td>" + value.RespComm + "</td></tr>";
                        disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Fieldworker Comments:</td><td>" + value.Fieldcomm + "</td></tr>";
                        disp.Text += "</table><br/>";
                    }
                }
            }
            /*GPS*/
            DataKibaliDataContext dbgps = new DataKibaliDataContext();
            var gpsitems = from t in dbgps.GPS_STATUS
                           where t.IDNumber == theId
                           select new
                           {
                               t.IDNumber,
                               t.GpsN,
                               t.GpsE
                           };

            double fieldtotal = 0;
            double treetotal = 0;
            foreach (var gvalue in gpsitems)
            {
                if (task == "")//to avoid clush with search by project
                {
                    string status = getsatus(theId, gvalue.GpsN, gvalue.GpsE);
                    string statuscolor = "";
                    if (status == "Paid") statuscolor = "white"; else statuscolor = "red";

                    disp.Text += "<table border=\"1\" width=\"80%\"><tr align=\"left\" bgcolor=\"black\"><th width=\"80%\" style=\"color:white\">GPS N:" + gvalue.GpsN + " - GPS E:" + gvalue.GpsE + "</th width=\"20%\"><th style=\"color:" + statuscolor + "\">  TOTAL: " + TotalPerGps(gvalue.GpsN, gvalue.GpsE, theId, task) + "FC - " + status + "</th></tr>";
                    disp.Text += "<tr align=\"center\"><td colspan=\"2\">";
                }
                /*field*/
                if (hasFields(theId, task))
                {
                    int fnumber = 0;

                    foreach (var fvalue in field)
                    {
                        if ((fvalue.GpsN == gvalue.GpsN) && (fvalue.GpsE == gvalue.GpsE))
                        {
                            fnumber += 1;

                            if (fnumber > 0)
                            {
                                if (fnumber==1)
                                {
                                    disp.Text += "<table border=\"0\">";
                                    disp.Text += "<tr align=\"center\"><td colspan=\"5\"><strong><u>FIELDS</u></strong></td></tr>";
                                }

                                string project = fvalue.ProjectTask;
                                if (project == "" || project == null) project = "None";
                                disp.Text += "<tr bgcolor=\"#D1DDF1\"><th>Field " + fnumber + "</th><th>Affecting Project/Task: " + project + "</th><th>Ownership: " + fvalue.Ownership + "</th><th>Dimension: " + fvalue.Dimension + "m2.</th><th>Cultiv. last 12 months: " + boolvalue(Convert.ToBoolean(fvalue.Cultiv)) + "</th></tr>";
                                disp.Text += "<tr><td colspan=\"5\">";
                                var crop =
                                    from Lecrop in dbfield.COMP_CROPs
                                    where Lecrop.FieldCode == fvalue.FieldCode
                                    select new
                                    {
                                        cr = Lecrop.Crop
                                    };
                                disp.Text += "<table align=\"center\">";
                                disp.Text += "<tr bgcolor=\"#EFF3FB\"><td>Crop Type</td><td>Unit Price</td><td>Total</td></tr>";
                                foreach (var cropvalue in crop)
                                {
                                    double price = Convert.ToInt32(getCropPrice(cropvalue.cr));
                                    double total = fvalue.Dimension * price;
                                    fieldtotal += total;
                                    disp.Text += "<tr><td>" + cropvalue.cr + "</td><td>" + price + "FC</td><td>" + total + "FC</td></tr>";
                                }
                            }
                            disp.Text += "</table>";
                            disp.Text += "</td></tr>";
                        }
                    }
                   if (fnumber > 0)
                    {
                        disp.Text += "</table>";
                    }
                }
                /*tree*/
                if (hasTrees(theId, task))
                {
                    int tnumber = 0;
                    foreach (var tvalue in tree)
                    {
                        if ((tvalue.GpsN == gvalue.GpsN) && (tvalue.GpsE == gvalue.GpsE))
                        {
                            tnumber += 1;
                            if (tnumber == 1)
                            {
                                disp.Text += "<table border=\"0\">";
                                disp.Text += "<tr align=\"center\"><td colspan=\"7\"><strong><u>TREES</u></strong></td></tr>";
                                disp.Text += "<tr bgcolor=\"#D1DDF1\" align=\"center\"><th>Tree</th><th>Affecting Project/Task</th><th>No. of trees</th><th>Unit Price</th><th>Total</th><th>Valeur Abres de remplacement</th><th>Net a payer</th></tr>";
                            }
                            double price = Convert.ToInt32(getTreePrice(tvalue.Treename));
                            double total = tvalue.Number * price;
                            double deduction = total * 0.20;
                            double net = total - deduction;
                            treetotal += net;
                            string project = tvalue.ProjectTask;
                            if (project == "" || project == null) project = "None";
                            disp.Text += "<tr align=\"center\"><td align=\"left\">" + tvalue.Treename + "</td><td>" + project + "</td><td>" + tvalue.Number + "</td><td>" + price + "FC</td><td>" + total + "FC</td><td>" + deduction + "FC</td><td>" + net + "FC</td></tr>";
                        }
                    }
                    if (tnumber > 0)
                    {
                        disp.Text += "</table>";
                    }
                }
                if (task == "")//to avoid clush with search by project
                {
                    disp.Text += "</td></tr></table>";//////////////////GPS Table
                }
            }
            foreach (var value in claimer)
            {
                compstatus = value.status;
            }
            double bigtotal = fieldtotal + treetotal;
            if ((field.Count() == 0) && (tree.Count() == 0)) disp.Text = "No record found";
            else
            {
                disp.Text += "<br /><table><tr bgcolor=\"black\" style=\"color:white\"><td><b>TOTAL: " + bigtotal + "FC<br /></td></tr></table>";
                if (!compstatus) disp.Text += "<br /><table><tr style=\"color:red\"><td><b>Compensation status: " + AgriCompStatusValue(compstatus) + "<br /></td></tr></table>";
                else if (compstatus) disp.Text += "<br /><table><tr style=\"color:black\"><td><b>Compensation status: " + AgriCompStatusValue(compstatus) + "<br /></td></tr></table>";
            }
        }
        public string getsatus(string id, string gpsn, string gpse)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var status =
                from thestatus in db.GPS_STATUS
                where thestatus.IDNumber == id && thestatus.GpsN == gpsn && thestatus.GpsE == gpse
                select new
                {
                    thestatus.Status
                };
            string returnstatus = "";
            foreach (var value in status)
            {
                if (value.Status == true) returnstatus = "Paid"; else returnstatus = "Pending";
            }
            return returnstatus;
        }
        public double TotalPerGps(string gpsn, string gpse, string theId, string task)
        {
            DataKibaliDataContext dbfield = new DataKibaliDataContext();
            var field =
                from thefield in dbfield.COMP_FIELDs
                where thefield.IDnumber == theId
                select new
                {
                    id = thefield.IDnumber,
                    Ownership = thefield.Ownership,
                    Dimension = thefield.Dimension,
                    Cultiv = thefield.Cultiv,
                    ProjectTask = thefield.ProjectTask,
                    FieldCode = thefield.FieldCode,
                    GpsN = thefield.GpsN, 
                    GpsE = thefield.GpsE
                };
            if (task != "")
            {
                field =
                from thefield in dbfield.COMP_FIELDs
                where thefield.IDnumber == theId && thefield.ProjectTask == task
                select new
                {
                    id = thefield.IDnumber,
                    Ownership = thefield.Ownership,
                    Dimension = thefield.Dimension,
                    Cultiv = thefield.Cultiv,
                    ProjectTask = thefield.ProjectTask,
                    FieldCode = thefield.FieldCode,
                    GpsN = thefield.GpsN,
                    GpsE = thefield.GpsE
                };
            }

            DataKibaliDataContext dbtree = new DataKibaliDataContext();
            var tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == theId
                    select new
                    {
                        id = thetree.IDnumber,
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask,
                        GpsN = thetree.GpsN,
                        GpsE = thetree.GpsE
                    };
            if (task != "")
            {
                tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == theId && thetree.ProjectTask == task
                    select new
                    {
                        id = thetree.IDnumber,
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask,
                        GpsN = thetree.GpsN,
                        GpsE = thetree.GpsE
                    };
            }
            double bigtotal = 0;
            double ftotal = 0;
            double ttotal = 0;
            foreach (var fvalue in field)
            {
                if ((fvalue.GpsN == gpsn) && (fvalue.GpsE == gpse) && (fvalue.id == theId))
                {

                    var crop =
                            from Lecrop in dbfield.COMP_CROPs
                            where Lecrop.FieldCode == fvalue.FieldCode
                            select new
                            {
                                cr = Lecrop.Crop
                            };
                    foreach (var cropvalue in crop)
                    {
                        double price = Convert.ToInt32(getCropPrice(cropvalue.cr));
                        double total = fvalue.Dimension * price;
                        ftotal += total;
                    }
                }

            }
            foreach (var tvalue in tree)
            {
                if ((tvalue.GpsN == gpsn) && (tvalue.GpsE == gpse) && (tvalue.id == theId))
                {
                    double price = Convert.ToInt32(getTreePrice(tvalue.Treename));
                    double total = tvalue.Number * price;
                    double deduction = total * 0.20;
                    double net = total - deduction;
                    ttotal += net;
                }
            }
            bigtotal = ftotal + ttotal;
            return bigtotal;
        }
        public void change(string id, string currentstatus)
        {
            DataKibaliDataContext dbclaimer = new DataKibaliDataContext();
            var claimer =
                from person in dbclaimer.HHCLAIMERs
                where person.IDnumber == id
                select person;
            foreach (var value in claimer)
            {
                if (currentstatus == "Concluded") value.AgriCompStatus = false;
                else if (currentstatus == "Pending") value.AgriCompStatus = true;
            }
            dbclaimer.SubmitChanges();
        }
        public bool savegpscoordinates(string id, string gpsn, string gpse)
        {
            using (DataKibaliDataContext db = new DataKibaliDataContext())
            {
                var coo_per_id = from t in db.GPS_STATUS
                            where t.IDNumber == id && t.GpsN == gpsn && t.GpsE == gpse
                            select new
                            {
                                t.IDNumber,
                                t.GpsN,
                                t.GpsE
                            };
                var coo_all = from t in db.GPS_STATUS
                              where t.GpsN == gpsn && t.GpsE == gpse
                              select new
                              {
                                  t.GpsN,
                                  t.GpsE
                              };
                if (coo_all.Count() > 0) //If coordinates already exist.
                {
                    if (coo_per_id.Count() == 1) //If coordinates exist for the same claimer
                    {
                        //do nothing
                        return true;
                    }
                    else return false;//coordinates already exist for a different claimer
                }
                else if (coo_per_id.Count() == 0) //If coordinates do not exist
                {
                    GPS_STATUS gpstatus = new GPS_STATUS();
                    gpstatus.IDNumber = id;
                    gpstatus.GpsN = gpsn;
                    gpstatus.GpsE = gpse;

                    db.GPS_STATUS.InsertOnSubmit(gpstatus);
                    db.SubmitChanges();
                    return true;
                }
                else return false;//for the sake of programing (but should not be reached)
            }
        }
        public string getidfromcoordinates(string gpsn, string gpse)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var coo_per_id = from t in db.GPS_STATUS
                             where t.GpsN == gpsn && t.GpsE == gpse
                             select new
                             {
                                 t.IDNumber,
                                 t.GpsN,
                                 t.GpsE
                             };
            foreach (var value in coo_per_id)
            {
                return value.IDNumber;
            }
            return "";
        }
        public string AgriCompStatusValue(bool b)
        {
            if (b) return "Concluded";
            else if (!b) return "Pending";
            return "";
        }
        public string boolvalue(bool value)
        {
            if (value) return "Yes"; else return "No";
        }
        public double GetTreesPrice(string id, string task)
        {
            DataKibaliDataContext dbtree = new DataKibaliDataContext();
            var tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == id
                    select new
                    {
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask
                    };
            if (task != "")
            {
                tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == id && thetree.ProjectTask == task
                    select new
                    {
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask
                    };
            }
            double treetotal = 0;

            foreach (var value in tree)
            {
                double price = Convert.ToInt32(getTreePrice(value.Treename));
                double total = value.Number * price;
                treetotal += total;
            }
            return treetotal;
        }

        public double GetFieldsPrice(string id, string task)
        {
            DataKibaliDataContext dbfield = new DataKibaliDataContext();
            var field =
                    from thefield in dbfield.COMP_FIELDs
                    where thefield.IDnumber == id
                    select new
                    {
                        Dimension = thefield.Dimension,
                        FieldCode = thefield.FieldCode
                    };
            if (task != "")
            {
                field =
                    from thefield in dbfield.COMP_FIELDs
                    where thefield.IDnumber == id && thefield.ProjectTask == task
                    select new
                    {
                        Dimension = thefield.Dimension,
                        FieldCode = thefield.FieldCode
                    };
            }
            double fieldtotal = 0;
            foreach (var value in field)
            {
                var crop =
                    from Lecrop in dbfield.COMP_CROPs
                    where Lecrop.FieldCode == value.FieldCode
                    select new
                    {
                        cr = Lecrop.Crop
                    };
                foreach (var cropvalue in crop)
                {
                    double price = Convert.ToInt32(getCropPrice(cropvalue.cr));
                    double total = value.Dimension * price;
                    fieldtotal += total;
                }
            }
            return fieldtotal;
        }
        public string getCropPrice(string croptype)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string price = (from p in db.CROPs
                            where p.Name == croptype
                            select p.Rate).First().ToString();
            return price;
        }
        public string getTreePrice(string treename)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string price = (from t in db.TREEs
                            where t.Name == treename
                            select t.Rate).First().ToString();
            return price;
        }
        /*Get ID from household*/
        public string GetID(string HHnumber)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string id = (from t in db.HHCLAIMERs
                         where t.HHNumber == HHnumber
                         select t.IDnumber).First().ToString();
            return id;
        }
        /*Get HHnumber from id*/
        public string GetHHnumber(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string hhn = (from t in db.HHCLAIMERs
                          where t.IDnumber == id
                          select t.HHNumber).First().ToString();
            return hhn;
        }
        /*Get HHhead from hhn*/
        public string GetHHHead(string hhn)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string hhh = (from t in db.HOUSEHOLDs
                          where t.HHNumber == hhn
                          select t.HHhead).First().ToString();
            return hhh;
        }
        public string GetVillage(string hhn)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string village = (from t in db.HOUSEHOLDs
                              where t.HHNumber == hhn
                              select t.Village).First().ToString();
            return village;
        }
        /*Get Claimer from id*/
        public string GetClaimer(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string claimer = (from t in db.HHCLAIMERs
                              where t.IDnumber == id
                              select t.HHFirstName + " " + t.HHFamName).First().ToString();
            return claimer;
        }
        public string GetFirstName(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string claimer = (from t in db.HHCLAIMERs
                              where t.IDnumber == id
                              select t.HHFirstName).First().ToString();
            return claimer;
        }
        public string GetMiddleName(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string claimer = (from t in db.HHCLAIMERs
                              where t.IDnumber == id
                              select t.HHMiddleName).First().ToString();
            return claimer;
        }
        public string GetFamilyName(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string claimer = (from t in db.HHCLAIMERs
                              where t.IDnumber == id
                              select t.HHFamName).First().ToString();
            return claimer;
        }
        public string GetInterviewer(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string Interviewer = (from t in db.HHCLAIMERs
                                  where t.IDnumber == id
                                  select t.Interviewer).First().ToString();
            return Interviewer;
        }
        public string Supervised(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string Sup = (from t in db.HHCLAIMERs
                          where t.IDnumber == id
                          select t.Supervised).First().ToString();
            return Sup;
        }
        public string Chiefed(string id)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string Chef = (from t in db.HHCLAIMERs
                           where t.IDnumber == id
                           select t.Chiefed).First().ToString();
            return Chef;
        }
        public string GetIntDate(string hhn)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            string dte = (from t in db.HOUSEHOLDs
                          where t.HHNumber == hhn
                          select t.InterviewDate).First().ToString();
            DateTime thedate = Convert.ToDateTime(dte);
            dte = thedate.ToString("MM/dd/yyyy");
            return dte;
        }
        /*Check if has trees in db*/
        public bool hasTrees(string Idtosearch, string task)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.COMP_TREEs.Any(x => x.IDnumber == Idtosearch);
            if (task != "") contains = db.COMP_TREEs.Any(x => x.IDnumber == Idtosearch && x.ProjectTask == task);
            return contains;
        }
        /*Check if has fields in db*/
        public bool hasFields(string Idtosearch, string task)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.COMP_FIELDs.Any(x => x.IDnumber == Idtosearch);
            if (task != "") contains = db.COMP_FIELDs.Any(x => x.IDnumber == Idtosearch && x.ProjectTask == task);
            return contains;
        }

        /*Check if House hold number exists in household table*/
        public bool isinHOUSEHOLD(string tosearch)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.HOUSEHOLDs.Any(x => x.HHNumber == tosearch);
            return contains;
        }
        /*Check if Claimer number exists in claimer table*/
        public bool isinHHCLAIMER(string tosearch)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.HHCLAIMERs.Any(x => x.IDnumber == tosearch);
            return contains;
        }





        /*PDF*/
        public string Createpdf(string theId)
        {
            DataKibaliDataContext dbclaimer = new DataKibaliDataContext();
            var claimer =
                from person in dbclaimer.HHCLAIMERs
                from hh in dbclaimer.HOUSEHOLDs
                where person.IDnumber == theId && person.HHNumber == hh.HHNumber
                select new
                {
                    HHNumber = hh.HHNumber,
                    village = hh.Village,
                    HHhead = hh.HHhead,
                    thedate = hh.InterviewDate,
                    photo = hh.PhotoPath,
                    person = person.HHFirstName,
                    first = person.HHFirstName,
                    mid = person.HHMiddleName,
                    fam = person.HHFamName,
                    id = person.IDnumber,
                    interviewer = person.Interviewer,
                    sup = person.Supervised,
                    chief = person.Chiefed
                };


            DataKibaliDataContext dbadd = new DataKibaliDataContext();
            var additional =
                from add in dbadd.FURTHER_INFOs
                where add.IDnumber == theId
                select new
                {
                    unresearched = add.FTunresearched,
                    location = add.Location,
                    RespComm = add.RespComm,
                    Fieldcomm = add.FieldComm
                };


            DataKibaliDataContext dbfield = new DataKibaliDataContext();
            var field =
                from thefield in dbfield.COMP_FIELDs
                where thefield.IDnumber == theId
                select new
                {
                    Ownership = thefield.Ownership,
                    Dimension = thefield.Dimension,
                    Cultiv = thefield.Cultiv,
                    ProjectTask = thefield.ProjectTask,
                    FieldCode = thefield.FieldCode
                };

            DataKibaliDataContext dbtree = new DataKibaliDataContext();
            var tree =
                    from thetree in dbtree.COMP_TREEs
                    where thetree.IDnumber == theId
                    select new
                    {
                        Treename = thetree.Tree,
                        Number = thetree.Number,
                        ProjectTask = thetree.ProjectTask
                    };

            /*Compiling PDF*/
            string path = HttpContext.Current.Server.MapPath("PDFs");
            Document doc = new Document();

            Random random = new Random();
            string pdfnumber = random.Next(0, 999999999) + "";
            string filename = theId + "_F" + pdfnumber + ".pdf";

            try
            {
                PdfWriter.GetInstance(doc, new FileStream(path + "/" + filename, FileMode.Create));
                doc.Open();

                Font bold = new Font(Font.FontFamily.UNDEFINED, Font.DEFAULTSIZE, Font.BOLD);
                Font italic = new Font(Font.FontFamily.UNDEFINED, Font.DEFAULTSIZE, Font.ITALIC);

                iTextSharp.text.Image jpg = iTextSharp.text.Image.GetInstance(HttpContext.Current.Server.MapPath("~\\kibali.jpg"));
                jpg.ScaleAbsolute(100f, 44f);
                jpg.Alignment = 1;
                doc.Add(jpg);
                Paragraph title = new Paragraph("COMPENSATION EVALUATION FORM\nFORMULAIRE DE COMPENSATION", bold);
                title.Alignment = 1;
                doc.Add(title);
                doc.Add(new Paragraph("\n"));

                Chunk GI = new Chunk("GENERAL INFORMATION", bold);
                GI.SetUnderline(1.0f, -1.5f);
                Phrase p1 = new Phrase(GI);
                Paragraph p = new Paragraph();
                p.SpacingAfter = 5;
                p.Add(p1);
                doc.Add(p);

                foreach (var value in claimer)
                {
                    /*
                    PdfPTable TableGeneral = new PdfPTable(2);
                    TableGeneral.HorizontalAlignment = 0;
                    TableGeneral.AddCell("First Name");
                    TableGeneral.AddCell(value.first);
                    TableGeneral.AddCell("Middle name");
                    TableGeneral.AddCell(value.mid);
                    TableGeneral.AddCell("Family name");
                    TableGeneral.AddCell(value.fam);
                    TableGeneral.AddCell("Id Number");
                    TableGeneral.AddCell(value.id);
                    TableGeneral.AddCell("Interviewer");
                    TableGeneral.AddCell(value.interviewer);
                    TableGeneral.AddCell("Verified by Fieldwork Supervisor");
                    TableGeneral.AddCell(boolvalue(Convert.ToBoolean(value.sup)));
                    TableGeneral.AddCell("Verified by Chef de village/Camp");
                    TableGeneral.AddCell(boolvalue(Convert.ToBoolean(value.chief)));

                    doc.Add(TableGeneral);
                    */
                    /*************************************/
                    PdfPTable table = new PdfPTable(2);
                    float[] widths = new float[] { 4f, 1f };
                    table.SetWidths(widths);
                    table.WidthPercentage = 100;
                    table.DefaultCell.Border = 0;
                    PdfPTable nested = new PdfPTable(2);
                    nested.DefaultCell.Border = 0;
                    nested.AddCell("First Name");
                    nested.AddCell(value.first);
                    nested.AddCell("Middle name");
                    nested.AddCell(value.mid);
                    nested.AddCell("Family name");
                    nested.AddCell(value.fam);
                    nested.AddCell("Id Number");
                    nested.AddCell(value.id);
                    nested.AddCell("Interviewer");
                    nested.AddCell(value.interviewer);
                    nested.AddCell("Verified by Fieldwork Supervisor");
                    nested.AddCell(boolvalue(Convert.ToBoolean(value.sup)));
                    nested.AddCell("Verified by Chef de village/Camp");
                    nested.AddCell(boolvalue(Convert.ToBoolean(value.chief)));
                    PdfPCell nesthousing = new PdfPCell(nested);
                    nesthousing.Padding = 0f;
                    table.AddCell(nesthousing);
                    PdfPCell bottom = new PdfPCell(new Phrase("bottom"));
                    //bottom.Colspan = 2;
                    if (value.photo == "1")
                    {
                        iTextSharp.text.Image tof;
                        tof = iTextSharp.text.Image.GetInstance(HttpContext.Current.Server.MapPath("~\\Photos\\" + value.HHNumber + "_thumb.jpg"));
                        jpg.Alignment = 1;
                        bottom.AddElement(tof);
                    }
                    else
                    {
                        Paragraph photo = new Paragraph("PHOTO");
                        photo.Alignment = 1;
                        bottom.AddElement(photo);
                    }
                    table.AddCell(bottom);
                    doc.Add(table);
                }


                doc.Add(new Paragraph("\n"));

                Chunk HD = new Chunk("HOUSEHOLD DETAILS", bold);
                HD.SetUnderline(1.0f, -1.5f);
                Phrase phr2 = new Phrase(HD);
                Paragraph p2 = new Paragraph();
                p2.SpacingAfter = 5;
                p2.Add(phr2);
                doc.Add(p2);

                foreach (var value in claimer)
                {
                    PdfPTable HH = new PdfPTable(1);
                    HH.HorizontalAlignment = 0;
                    PdfPTable TableHouse = new PdfPTable(2);
                    TableHouse.DefaultCell.Border = 0;
                    DateTime ladate = Convert.ToDateTime(value.thedate);
                    TableHouse.AddCell("Village");
                    TableHouse.AddCell(value.village);
                    TableHouse.AddCell("HH number");
                    TableHouse.AddCell(value.HHNumber);
                    TableHouse.AddCell("Name of Household head");
                    TableHouse.AddCell(value.HHhead);
                    TableHouse.AddCell("Interview date");
                    TableHouse.AddCell(ladate.ToString("MMMM dd, yyyy"));
                    HH.AddCell(TableHouse);
                    doc.Add(HH);
                }

                doc.Add(new Paragraph("\n"));

                /*additional info*/
                if (additional.Count() > 0)
                {
                    if ((additional.First().unresearched == false) && (additional.First().location == "") && (additional.First().RespComm == "") && (additional.First().Fieldcomm == ""))
                    {
                    }
                    else
                    {
                        Chunk AI = new Chunk("ADDITIONAL INFORMATION", bold);
                        AI.SetUnderline(1.0f, -1.5f);
                        Phrase phr3 = new Phrase(AI);
                        Paragraph p3 = new Paragraph();
                        p3.SpacingAfter = 5;
                        p3.Add(phr3);
                        doc.Add(p3);

                        foreach (var value in additional)
                        {
                            PdfPTable TA = new PdfPTable(1);
                            TA.HorizontalAlignment = 0;
                            PdfPTable TableAdditional = new PdfPTable(2);
                            TableAdditional.DefaultCell.Border = 0;
                            TableAdditional.AddCell("Other Fields/Trees Unresearched?");
                            TableAdditional.AddCell(boolvalue(Convert.ToBoolean(value.unresearched)));
                            TableAdditional.AddCell("Location");
                            TableAdditional.AddCell(value.location);
                            TableAdditional.AddCell("Respondant Comments");
                            TableAdditional.AddCell(value.RespComm);
                            TableAdditional.AddCell("Fieldworker Comments");
                            TableAdditional.AddCell(value.Fieldcomm);
                            TA.AddCell(TableAdditional);
                            doc.Add(TA);
                        }
                        doc.Add(new Paragraph("\n"));
                    }
                }

                /*field*/
                double fieldtotal = 0;
                if (hasFields(theId, ""))
                {
                    Chunk F = new Chunk("FIELDS", bold);
                    F.SetUnderline(1.0f, -1.5f);
                    Phrase phr4 = new Phrase(F);
                    Paragraph p4 = new Paragraph();
                    p4.SpacingAfter = 5;
                    p4.Add(phr4);
                    doc.Add(p4);

                    PdfPTable TableFields = new PdfPTable(5);
                    TableFields.HorizontalAlignment = 0;
                    TableFields.WidthPercentage = 100;
                    int fnumber = 0;
                    foreach (var value in field)
                    {
                        fnumber += 1;
                        string project = value.ProjectTask;
                        if (project == "" || project == null) project = "None";
                        TableFields.AddCell(new Phrase("Field " + fnumber, bold));
                        TableFields.AddCell(new Phrase("Affecting Project/Task: " + project, bold));
                        TableFields.AddCell(new Phrase("Ownership: " + value.Ownership, bold));
                        TableFields.AddCell(new Phrase("Dimension: " + value.Dimension + "m2.", bold));
                        TableFields.AddCell(new Phrase("Cultiv. last 12 months: " + boolvalue(Convert.ToBoolean(value.Cultiv)), bold));

                        var crop =
                            from Lecrop in dbfield.COMP_CROPs
                            where Lecrop.FieldCode == value.FieldCode
                            select new
                            {
                                cr = Lecrop.Crop
                            };
                        PdfPTable TableCrops = new PdfPTable(3);
                        TableCrops.HorizontalAlignment = 1;
                        TableCrops.AddCell(new Phrase("Crop Type", bold));
                        TableCrops.AddCell(new Phrase("Unit Price", bold));
                        TableCrops.AddCell(new Phrase("Total", bold));
                        foreach (var cropvalue in crop)
                        {
                            double price = Convert.ToInt32(getCropPrice(cropvalue.cr));
                            double total = value.Dimension * price;
                            fieldtotal += total;
                            TableCrops.AddCell(cropvalue.cr);
                            TableCrops.AddCell(price + "FC");
                            TableCrops.AddCell(total + "FC");
                        }
                        PdfPCell cropcell = new PdfPCell();
                        cropcell.Colspan = 5;
                        cropcell.AddElement(TableCrops);
                        TableFields.AddCell(cropcell);
                    }
                    PdfPCell footcell = new PdfPCell(new Phrase("Field(s) Total: " + fieldtotal + "FC"));
                    footcell.Colspan = 5;
                    footcell.HorizontalAlignment = 1;
                    TableFields.AddCell(footcell);
                    doc.Add(TableFields);

                    doc.Add(new Paragraph("\n"));
                }

                /*tree*/
                double treetotal = 0;
                if (hasTrees(theId, ""))
                {

                    Chunk T = new Chunk("TREES", bold);
                    T.SetUnderline(1.0f, -1.5f);
                    Phrase phr5 = new Phrase(T);
                    Paragraph p5 = new Paragraph();
                    p5.SpacingAfter = 5;
                    p5.Add(phr5);
                    doc.Add(p5);

                    PdfPTable TableTrees = new PdfPTable(7);
                    TableTrees.HorizontalAlignment = 0;
                    TableTrees.WidthPercentage = 100;

                    int tnumber = 0;

                    TableTrees.AddCell(new Phrase("Tree", bold));
                    TableTrees.AddCell(new Phrase("Affecting Project/Task", bold));
                    TableTrees.AddCell(new Phrase("No. of trees", bold));
                    TableTrees.AddCell(new Phrase("Unit Price", bold));
                    TableTrees.AddCell(new Phrase("Total", bold));
                    TableTrees.AddCell(new Phrase("Valeur Abres de remplacement", bold));
                    TableTrees.AddCell(new Phrase("Net a payer", bold));

                    foreach (var value in tree)
                    {
                        tnumber += 1;
                        double price = Convert.ToInt32(getTreePrice(value.Treename));
                        double total = value.Number * price;
                        double deduction = total * 0.20;
                        double net = total - deduction;
                        treetotal += net;
                        string project = value.ProjectTask;
                        if (project == "" || project == null) project = "None";
                        TableTrees.AddCell(value.Treename);
                        TableTrees.AddCell(project);
                        TableTrees.AddCell(value.Number + "");
                        TableTrees.AddCell(price + "FC");
                        TableTrees.AddCell(total + "FC");
                        TableTrees.AddCell(deduction + "FC");
                        TableTrees.AddCell(net + "FC");
                    }
                    PdfPCell footcell = new PdfPCell(new Phrase("Tree(s) Total: " + treetotal + "FC"));
                    footcell.Colspan = 5;
                    footcell.HorizontalAlignment = 1;
                    TableTrees.AddCell(footcell);
                    doc.Add(TableTrees);

                }
                double bigtotal = fieldtotal + treetotal;
                if ((field.Count() == 0) && (tree.Count() == 0)) { }
                else
                {
                    Paragraph tot = new Paragraph("TOTAL: " + bigtotal + "FC", bold);
                    tot.Alignment = 1;
                    doc.Add(tot);
                    doc.Add(new Paragraph("\n"));
                }
                string dots = "__________________________________";
                //doc.Add(Chunk.NEXTPAGE);
                PdfPTable TableConsent = new PdfPTable(2);
                TableConsent.HorizontalAlignment = 1;
                TableConsent.WidthPercentage = 100;
                TableConsent.DefaultCell.Border = 0;
                TableConsent.AddCell(dots);
                TableConsent.AddCell(dots);
                TableConsent.AddCell("Nom du Bénéficiaire");
                TableConsent.AddCell("Date et Signature");
                TableConsent.AddCell(" ");
                TableConsent.AddCell(" ");
                TableConsent.AddCell(dots);
                TableConsent.AddCell(dots);
                TableConsent.AddCell("Nom du Représentant KibaliGold");
                TableConsent.AddCell("Date et Signature");
                TableConsent.AddCell(" ");
                TableConsent.AddCell(" ");
                TableConsent.AddCell(dots);
                TableConsent.AddCell(dots);
                TableConsent.AddCell("Nom du Témoin");
                TableConsent.AddCell("Date et Signature");
                TableConsent.AddCell(" ");
                TableConsent.AddCell(" ");
                TableConsent.AddCell(dots);
                TableConsent.AddCell(dots);
                TableConsent.AddCell("Nom du Représentant du Gouvernement");
                TableConsent.AddCell("Date et Signature");
                doc.Add(TableConsent);
                doc.Add(new Paragraph("\n"));
                doc.Add(new Paragraph("En apposant ma signature sur ce formulaire de compensation résumé ci-haut, je confirme que j’ai été consulté dans le processus et je consens:", italic));
                doc.Add(new Paragraph("  - Que J’ai reçu la compensation de mes biens affectés par Kibali Gold Project.", italic));
                doc.Add(new Paragraph("  - Je laisserai vacante ma parcelle/concession dans les 7 jours suivant le plan particulier de", italic));
                doc.Add(new Paragraph("    déménagement de mon village.", italic));
            }
            catch (DocumentException dex)
            {
                throw (dex);
            }
            catch (IOException ioex)
            {
                throw (ioex);
            }
            finally
            {
                doc.Close();
            }
            return filename;
        }
    }
}