﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.Data;

namespace basekibali
{
    public partial class PendingAll : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (User.Identity.IsAuthenticated) { }
            else
                Response.Redirect("~/Default.aspx");

            dynatable(false);
            if (Page.IsPostBack)
            {
                dynatable(false);
            }
        }
        protected void btnsearch_Click(object sender, EventArgs e)
        {
            /*force page.ispostback*/
        }
        private void dynatable(bool status)
        {
            lblView.Text = "";
            DataKibaliDataContext dbclaimer = new DataKibaliDataContext();
            var claimer =
                from person in dbclaimer.HHCLAIMERs
                from hh in dbclaimer.HOUSEHOLDs
                where person.HHNumber == hh.HHNumber && person.AgriCompStatus == status
                select new
                {
                    HHFirstName = person.HHFirstName,
                    HHMiddleName = person.HHMiddleName,
                    HHFamName = person.HHFamName,
                    IDnumber = person.IDnumber,
                    Village = hh.Village,
                };

            if (claimer.Count() > 0)
            {
                lblView.Text = "<b><u>Pending compensation</u></b><br /><br />"; 
                HtmlTable tblDynamic = new HtmlTable();
                double total = 0;
                double bigtotal = 0;
                double rate = 0;
                double usd = 0;

                HtmlTableRow tblHeadRow = new HtmlTableRow();
                tblHeadRow.Align = "center";
                tblHeadRow.BgColor = "#D1DDF1";
                tblHeadRow.Style.Add("font-weight", "bold");
                HtmlTableCell Fullname = new HtmlTableCell();
                Fullname.InnerText = "FULL NAME";
                HtmlTableCell ID = new HtmlTableCell();
                ID.InnerText = "ID NUMBER";
                HtmlTableCell Vill = new HtmlTableCell();
                Vill.InnerText = "VILLAGE";
                HtmlTableCell Compensation = new HtmlTableCell();
                Compensation.InnerText = "COMPENSATION";
                HtmlTableCell USDollar = new HtmlTableCell();
                USDollar.InnerText = "USD";

                tblHeadRow.Controls.Add(Fullname);
                tblHeadRow.Controls.Add(ID);
                tblHeadRow.Controls.Add(Vill);
                tblHeadRow.Controls.Add(Compensation);
                if (rate != 0) tblHeadRow.Controls.Add(USDollar);
                tblDynamic.Controls.Add(tblHeadRow);

                Master master = new Master();
                string evenrow = "#f4f7fb";
                int row = 0;
                foreach (var value in claimer)
                {
                    row += 1;
                    total = master.GetTreesPrice(value.IDnumber,"") + master.GetFieldsPrice(value.IDnumber,"");
                    usd = Math.Round(total / rate, 2);
                    bigtotal += total;

                    HtmlTableRow tblRowDef = new HtmlTableRow();
                    tblRowDef.Align = "left";
                    if (row == 0) tblRowDef.BgColor = evenrow;

                    HtmlTableCell HHName = new HtmlTableCell();
                    HHName.InnerText = value.HHFirstName + " " + value.HHMiddleName + " " + value.HHFamName;

                    HtmlTableCell IDnumber = new HtmlTableCell();
                    IDnumber.InnerText = value.IDnumber;

                    HtmlTableCell HHVillage = new HtmlTableCell();
                    HHVillage.InnerText = value.Village;

                    HtmlTableCell Celltotal = new HtmlTableCell();
                    Celltotal.Align = "center";
                    Celltotal.InnerText = total + "FC";

                    HtmlTableCell Cellusd = new HtmlTableCell();
                    Cellusd.Align = "center";
                    Cellusd.InnerText = usd + "$";


                    tblRowDef.Controls.Add(HHName);
                    tblRowDef.Controls.Add(IDnumber);
                    tblRowDef.Controls.Add(HHVillage);
                    tblRowDef.Controls.Add(Celltotal);
                    if (rate != 0) tblRowDef.Controls.Add(Cellusd);

                    tblDynamic.Controls.Add(tblRowDef);
                    if (row == 1) row = -1;
                }
                double totusd = Math.Round(bigtotal / rate, 2);
                HtmlTableRow tblFootRow = new HtmlTableRow();
                tblFootRow.Align = "center";
                tblFootRow.BgColor = "#D1DDF1";
                tblFootRow.Style.Add("font-weight", "bold");
                HtmlTableCell Bigtot = new HtmlTableCell();
                Bigtot.Align = "right";
                Bigtot.ColSpan = 3;
                Bigtot.InnerText = "TOTAL:";
                HtmlTableCell BigtotFc = new HtmlTableCell();
                BigtotFc.Align = "center";
                BigtotFc.InnerText = bigtotal + "FC";
                HtmlTableCell BigtotUsd = new HtmlTableCell();
                BigtotUsd.Align = "center";
                if (rate != 0) BigtotUsd.InnerText = totusd + "$";

                tblFootRow.Controls.Add(Bigtot);
                tblFootRow.Controls.Add(BigtotFc);
                if (rate != 0)  tblFootRow.Controls.Add(BigtotUsd);
                tblDynamic.Controls.Add(tblFootRow);

                pnlDynamic.Controls.Add(tblDynamic);
            }
            else lblView.Text = "No record found";
        }
        protected void lnkEmployeeWhole_Click(object sender, CommandEventArgs e)
        {
            Response.Redirect("View.aspx?id=" + e.CommandArgument + "&proj=");
        }
    }
}