﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;

using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web.UI.HtmlControls;

namespace basekibali
{
    public class PhotoUploader
    {
        public bool ResizeImageAndUpload(System.IO.FileStream newFile, string folderPathAndFilenameNoExtension, double maxHeight, double maxWidth)
        {

            try
            {
                // Declare variable for the conversion
                float ratio;

                // Create variable to hold the image
                System.Drawing.Image thisImage = System.Drawing.Image.FromStream(newFile);

                // Get height and width of current image
                int width = (int)thisImage.Width;
                int height = (int)thisImage.Height;

                // Ratio and conversion for new size
                if (width > maxWidth)
                {
                    ratio = (float)width / (float)maxWidth;
                    width = (int)(width / ratio);
                    height = (int)(height / ratio);
                }

                // Ratio and conversion for new size
                if (height > maxHeight)
                {
                    ratio = (float)height / (float)maxHeight;
                    height = (int)(height / ratio);
                    width = (int)(width / ratio);
                }

                // Create "blank" image for drawing new image
                Bitmap outImage = new Bitmap(width, height);
                Graphics outGraphics = Graphics.FromImage(outImage);
                SolidBrush sb = new SolidBrush(System.Drawing.Color.White);


                // Fill "blank" with new sized image
                outGraphics.FillRectangle(sb, 0, 0, outImage.Width, outImage.Height);
                outGraphics.DrawImage(thisImage, 0, 0, outImage.Width, outImage.Height);
                sb.Dispose();
                outGraphics.Dispose();
                thisImage.Dispose();

                // Save new image as jpgs
                outImage.Save(HttpContext.Current.Server.MapPath(folderPathAndFilenameNoExtension + ".jpg"), System.Drawing.Imaging.ImageFormat.Jpeg);
                outImage.Dispose();

                return true;

            }
            catch (Exception)
            {
                return false;
            }
        }
        public void savephoto(Label lblInfo_, FileUpload fileUploader_, string Id)
        {
            lblInfo_.Text = "";
            //Path to store uploaded files on server - make sure your paths are unique
            string folderPath = "~\\Photos";
            string filePath = "~\\Photos\\" + Id;
            string thumbPath = "~\\Photos\\" + Id + "_thumb";

            bool IsExists = System.IO.Directory.Exists(HttpContext.Current.Server.MapPath(folderPath));
            if (!IsExists)
            {
                System.IO.Directory.CreateDirectory(HttpContext.Current.Server.MapPath(folderPath));
            }
            // Check that there is a file
            if (fileUploader_.PostedFile != null)
            {
                // Check file size (mustn’t be 0)
                HttpPostedFile myFile = fileUploader_.PostedFile;
                int nFileLen = myFile.ContentLength;
                if ((nFileLen > 0) && (nFileLen < 3145728))
                {
                    if ((System.IO.Path.GetExtension(myFile.FileName).ToLower() == ".jpg") || (System.IO.Path.GetExtension(myFile.FileName).ToLower() == ".jpeg"))
                    {
                        // Read file into a data stream
                        byte[] myData = new Byte[nFileLen];
                        myFile.InputStream.Read(myData, 0, nFileLen);
                        myFile.InputStream.Dispose();

                        // Save the stream to disk as temporary file. make sure the path is unique!
                        System.IO.FileStream newFile
                                = new System.IO.FileStream(HttpContext.Current.Server.MapPath(filePath + "_temp.jpg"),
                                                            System.IO.FileMode.Create);
                        newFile.Write(myData, 0, myData.Length);

                        // run ALL the image optimisations you want here..... make sure your paths are unique
                        // you can use these booleans later if you need the results for your own labels or so.
                        // dont call the function after the file has been closed.
                        bool success = ResizeImageAndUpload(newFile, thumbPath, 200, 200);
                        success = ResizeImageAndUpload(newFile, filePath, 768, 1024);
                        // tidy up and delete the temp file.
                        newFile.Close();
                        System.IO.File.Delete(HttpContext.Current.Server.MapPath(filePath + "_temp.jpg"));

                        if (isinHOUSEHOLD(Id))
                        {
                            DataKibaliDataContext db = new DataKibaliDataContext();
                            HOUSEHOLD thehouse = (from x in db.HOUSEHOLDs
                                                  where x.HHNumber == Id
                                                  select x).First();
                            thehouse.PhotoPath = "1";
                            db.SubmitChanges();
                            
                            lblInfo_.Text = "1";
                        }
                    }
                    else lblInfo_.Text = "-2";
                }
                else if (nFileLen == 0) lblInfo_.Text = "0";
                else if (nFileLen > 2097152) lblInfo_.Text = "-1";
            }
        }//void savephoto
        /*Check if House hold number exists in household table*/
        private bool isinHOUSEHOLD(string tosearch)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.HOUSEHOLDs.Any(x => x.HHNumber == tosearch);
            return contains;
        }
    }
}