﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace basekibali
{
    public partial class updatestatus : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (User.Identity.IsAuthenticated) { }
            else
                Response.Redirect("~/Default.aspx");

            if (Page.IsPostBack)
            {
                dynatable(Request["id"]);
            }
        } 

        private void dynatable(string id)
        {
            pnlDynamic.Controls.Clear();
            
            DataKibaliDataContext dbgps = new DataKibaliDataContext();
            var gpsitems = from t in dbgps.GPS_STATUS
                           where t.IDNumber == id
                           select new
                           {
                               t.IDNumber,
                               t.GpsN,
                               t.GpsE,
                               t.Status
                           };
            
            HtmlTable tblDynamic = new HtmlTable(); 

            if (gpsitems.Count() > 0)
            {
                HtmlTableRow tblHeadRow = new HtmlTableRow();

                tblHeadRow.Align = "center";
                tblHeadRow.BgColor = "#D1DDF1";
                tblHeadRow.Style.Add("font-weight", "bold");
                HtmlTableCell GPSN = new HtmlTableCell();
                GPSN.InnerText = "GPS N";
                HtmlTableCell GPSE = new HtmlTableCell();
                GPSE.InnerText = "GPS E";
                HtmlTableCell Status = new HtmlTableCell();
                Status.InnerText = "Status";
                HtmlTableCell Update = new HtmlTableCell();
                Update.InnerText = "";

                tblHeadRow.Controls.Add(GPSN);
                tblHeadRow.Controls.Add(GPSE);
                tblHeadRow.Controls.Add(Status);
                //tblHeadRow.Controls.Add(Update);

                tblDynamic.Controls.Add(tblHeadRow);
            }
            int linkid = 0;
            foreach (var value in gpsitems)
            {
                linkid += 1;

                HtmlTableRow tblRowDetails = new HtmlTableRow();

                HtmlTableCell Cellgpsn = new HtmlTableCell();
                Cellgpsn.Align = "center";
                Cellgpsn.InnerText = value.GpsN;

                HtmlTableCell Cellgpse = new HtmlTableCell();
                Cellgpse.Align = "center";
                Cellgpse.InnerText = value.GpsE;

                string curstatus;
                if (value.Status == true) curstatus = "Paid"; else curstatus = "Pending";

                HtmlTableCell Cellstatus = new HtmlTableCell();
                Cellstatus.Align = "center";
                Cellstatus.InnerText = curstatus;

                HtmlTableCell uplink = new HtmlTableCell();

                LinkButton lnkview = new LinkButton();
                lnkview.ID = "linkid" + linkid;
                lnkview.Text = "Change";
                lnkview.CommandArgument = value.IDNumber + "|" + value.GpsN + "|"+ value.GpsE;
                lnkview.Command += lnkUpdate_Click;

                uplink.Controls.Add(lnkview);

                tblRowDetails.Controls.Add(Cellgpsn);
                tblRowDetails.Controls.Add(Cellgpse);
                tblRowDetails.Controls.Add(Cellstatus);
                tblRowDetails.Controls.Add(uplink);

                tblDynamic.Controls.Add(tblRowDetails);
            }
            pnlDynamic.Controls.Add(tblDynamic);
        }
        protected void lnkUpdate_Click(object sender, CommandEventArgs e)
        {
            Master master = new Master();
            int accesslevel = master.GetAccessLevel(User.Identity.Name.ToString());
            if (accesslevel == 3)
            {
                string argument = e.CommandArgument + "";
                string[] args = argument.Split('|');

                string id = args[0];
                string gpsn = args[1];
                string gpse = args[2];

                DataKibaliDataContext db = new DataKibaliDataContext();
                var items = from t in db.GPS_STATUS
                            where t.IDNumber == id && t.GpsN == gpsn && t.GpsE == gpse
                            select t;
                foreach (var value in items)
                {
                    if (value.Status == true) value.Status = false;
                    else if (value.Status == false) value.Status = true;
                    else if (value.Status == null) value.Status = true;
                    else value.Status = false;
                }
                db.SubmitChanges();
                dynatable(Request["id"]);
            }
            else Response.Write("<script>alert('You do not have the sufficient privileges to perform this operation');</script>");

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            handlepageload.Visible = false;
        }
        protected void CloseWindow_Click(object sender, EventArgs e)
        {
            ClientScript.RegisterStartupScript(typeof(Page), "closePage", "window.close();", true);
        }
    }
}